package de.uebungstool.uebungstool.paging.services;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import de.uebungstool.uebungstool.paging.data.PagingDiagram;
import de.uebungstool.uebungstool.paging.data.TableCell;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.logging.Logger;
import org.junit.jupiter.api.Test;

class PagingServiceTest {
  private static final Logger log = Logger.getLogger(PagingServiceTest.class.getName());

  @Test
  void evaluate() throws JsonProcessingException {
    String fifoDiagram =
        "{\"diagram\":[[{\"page\":1,\"flag\":-1,\"i\":0,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":0},{\"page\":3,\"flag\":-1,\"i\":1,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":1},{\"page\":5,\"flag\":-1,\"i\":2,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":3,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":3,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":3,\"j\":2},{\"page\":4,\"flag\":-1,\"i\":3,\"j\":3}],[{\"page\":2,\"flag\":-1,\"i\":4,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":4,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":4,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":4,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":5,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":5,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":5,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":5,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":6,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":6,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":6,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":6,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":7,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":7,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":7,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":7,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":8,\"j\":0},{\"page\":1,\"flag\":-1,\"i\":8,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":8,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":8,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":9,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":9,\"j\":1},{\"page\":6,\"flag\":-1,\"i\":9,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":9,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":10,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":10,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":10,\"j\":2},{\"page\":5,\"flag\":-1,\"i\":10,\"j\":3}],[{\"page\":3,\"flag\":-1,\"i\":11,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":11,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":11,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":11,\"j\":3}]],\"callList\":[1,3,5,4,2,4,3,2,1,6,5,3],\"rwList\":[false,true,false,false,true,true,true,false,false,false,false,true],\"pageFaults\":[0,1,2,3,4,8,9,10,11],\"writeBacks\":[],\"strategy\":\"fifo\",\"frameCount\":4}";
    String clockDiagram =
        "{\"diagram\":[[{\"page\":12,\"flag\":11,\"i\":0,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":3},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":4},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":5},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":6},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":7}],[{\"page\":-1,\"flag\":11,\"i\":1,\"j\":0},{\"page\":11,\"flag\":11,\"i\":1,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":3},{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":4},{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":5},{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":6},{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":7}],[{\"page\":-1,\"flag\":11,\"i\":2,\"j\":0},{\"page\":-1,\"flag\":11,\"i\":2,\"j\":1},{\"page\":13,\"flag\":11,\"i\":2,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":3},{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":4},{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":5},{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":6},{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":7}],[{\"page\":-1,\"flag\":11,\"i\":3,\"j\":0},{\"page\":-1,\"flag\":11,\"i\":3,\"j\":1},{\"page\":-1,\"flag\":11,\"i\":3,\"j\":2},{\"page\":14,\"flag\":11,\"i\":3,\"j\":3},{\"page\":-1,\"flag\":-1,\"i\":3,\"j\":4},{\"page\":-1,\"flag\":-1,\"i\":3,\"j\":5},{\"page\":-1,\"flag\":-1,\"i\":3,\"j\":6},{\"page\":-1,\"flag\":-1,\"i\":3,\"j\":7}],[{\"page\":-1,\"flag\":11,\"i\":4,\"j\":0},{\"page\":-1,\"flag\":11,\"i\":4,\"j\":1},{\"page\":-1,\"flag\":11,\"i\":4,\"j\":2},{\"page\":-1,\"flag\":11,\"i\":4,\"j\":3},{\"page\":2,\"flag\":11,\"i\":4,\"j\":4},{\"page\":-1,\"flag\":-1,\"i\":4,\"j\":5},{\"page\":-1,\"flag\":-1,\"i\":4,\"j\":6},{\"page\":-1,\"flag\":-1,\"i\":4,\"j\":7}],[{\"page\":-1,\"flag\":11,\"i\":5,\"j\":0},{\"page\":-1,\"flag\":11,\"i\":5,\"j\":1},{\"page\":-1,\"flag\":11,\"i\":5,\"j\":2},{\"page\":-1,\"flag\":11,\"i\":5,\"j\":3},{\"page\":-1,\"flag\":11,\"i\":5,\"j\":4},{\"page\":1,\"flag\":11,\"i\":5,\"j\":5},{\"page\":-1,\"flag\":-1,\"i\":5,\"j\":6},{\"page\":-1,\"flag\":-1,\"i\":5,\"j\":7}],[{\"page\":-1,\"flag\":11,\"i\":6,\"j\":0},{\"page\":-1,\"flag\":11,\"i\":6,\"j\":1},{\"page\":-1,\"flag\":11,\"i\":6,\"j\":2},{\"page\":-1,\"flag\":11,\"i\":6,\"j\":3},{\"page\":-1,\"flag\":11,\"i\":6,\"j\":4},{\"page\":-1,\"flag\":11,\"i\":6,\"j\":5},{\"page\":3,\"flag\":11,\"i\":6,\"j\":6},{\"page\":-1,\"flag\":-1,\"i\":6,\"j\":7}],[{\"page\":-1,\"flag\":11,\"i\":7,\"j\":0},{\"page\":-1,\"flag\":11,\"i\":7,\"j\":1},{\"page\":-1,\"flag\":11,\"i\":7,\"j\":2},{\"page\":-1,\"flag\":11,\"i\":7,\"j\":3},{\"page\":-1,\"flag\":11,\"i\":7,\"j\":4},{\"page\":-1,\"flag\":11,\"i\":7,\"j\":5},{\"page\":-1,\"flag\":11,\"i\":7,\"j\":6},{\"page\":9,\"flag\":11,\"i\":7,\"j\":7}],[{\"page\":-1,\"flag\":11,\"i\":8,\"j\":0},{\"page\":-1,\"flag\":11,\"i\":8,\"j\":1},{\"page\":-1,\"flag\":11,\"i\":8,\"j\":2},{\"page\":-1,\"flag\":11,\"i\":8,\"j\":3},{\"page\":-1,\"flag\":11,\"i\":8,\"j\":4},{\"page\":-1,\"flag\":11,\"i\":8,\"j\":5},{\"page\":-1,\"flag\":11,\"i\":8,\"j\":6},{\"page\":-1,\"flag\":11,\"i\":8,\"j\":7}],[{\"page\":5,\"flag\":11,\"i\":9,\"j\":0},{\"page\":-1,\"flag\":10,\"i\":9,\"j\":1},{\"page\":-1,\"flag\":10,\"i\":9,\"j\":2},{\"page\":-1,\"flag\":10,\"i\":9,\"j\":3},{\"page\":-1,\"flag\":10,\"i\":9,\"j\":4},{\"page\":-1,\"flag\":10,\"i\":9,\"j\":5},{\"page\":-1,\"flag\":10,\"i\":9,\"j\":6},{\"page\":-1,\"flag\":10,\"i\":9,\"j\":7}],[{\"page\":-1,\"flag\":11,\"i\":10,\"j\":0},{\"page\":7,\"flag\":11,\"i\":10,\"j\":1},{\"page\":-1,\"flag\":10,\"i\":10,\"j\":2},{\"page\":-1,\"flag\":10,\"i\":10,\"j\":3},{\"page\":-1,\"flag\":10,\"i\":10,\"j\":4},{\"page\":-1,\"flag\":10,\"i\":10,\"j\":5},{\"page\":-1,\"flag\":10,\"i\":10,\"j\":6},{\"page\":-1,\"flag\":10,\"i\":10,\"j\":7}],[{\"page\":-1,\"flag\":11,\"i\":11,\"j\":0},{\"page\":-1,\"flag\":11,\"i\":11,\"j\":1},{\"page\":10,\"flag\":11,\"i\":11,\"j\":2},{\"page\":-1,\"flag\":10,\"i\":11,\"j\":3},{\"page\":-1,\"flag\":10,\"i\":11,\"j\":4},{\"page\":-1,\"flag\":10,\"i\":11,\"j\":5},{\"page\":-1,\"flag\":10,\"i\":11,\"j\":6},{\"page\":-1,\"flag\":10,\"i\":11,\"j\":7}]],\"callList\":[12,11,13,14,2,1,3,9,2,5,7,10],\"rwList\":[true,true,true,true,true,true,true,true,true,true,true,true],\"pageFaults\":[0,1,2,4,3,5,6,7,9,10,11],\"writeBacks\":[9,11,10],\"strategy\":\"clock\",\"frameCount\":8}";
    String lRUDiagram =
        "{\"diagram\":[[{\"page\":2,\"flag\":1,\"i\":0,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":0},{\"page\":5,\"flag\":2,\"i\":1,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":1},{\"page\":6,\"flag\":3,\"i\":2,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":3,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":3,\"j\":1},{\"page\":-1,\"flag\":4,\"i\":3,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":3,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":4,\"j\":0},{\"page\":-1,\"flag\":5,\"i\":4,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":4,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":4,\"j\":3}],[{\"page\":-1,\"flag\":6,\"i\":5,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":5,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":5,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":5,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":6,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":6,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":6,\"j\":2},{\"page\":4,\"flag\":7,\"i\":6,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":7,\"j\":0},{\"page\":-1,\"flag\":8,\"i\":7,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":7,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":7,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":8,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":8,\"j\":1},{\"page\":1,\"flag\":9,\"i\":8,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":8,\"j\":3}],[{\"page\":6,\"flag\":10,\"i\":9,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":9,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":9,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":9,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":10,\"j\":0},{\"page\":-1,\"flag\":11,\"i\":10,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":10,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":10,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":11,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":11,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":11,\"j\":2},{\"page\":-1,\"flag\":12,\"i\":11,\"j\":3}]],\"callList\":[2,5,6,6,5,2,4,5,1,6,5,4],\"rwList\":[true,true,true,true,true,true,true,true,true,true,true,true],\"pageFaults\":[0,1,2,6,8,9],\"writeBacks\":[],\"strategy\":\"lru\",\"frameCount\":4}";
    String nFUDiagram =
        "{\"diagram\":[[{\"page\":5,\"flag\":1,\"i\":0,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":0,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":0},{\"page\":3,\"flag\":1,\"i\":1,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":1,\"j\":3}],[{\"page\":-1,\"flag\":2,\"i\":2,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":2,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":3,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":3,\"j\":1},{\"page\":2,\"flag\":1,\"i\":3,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":3,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":4,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":4,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":4,\"j\":2},{\"page\":6,\"flag\":1,\"i\":4,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":5,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":5,\"j\":1},{\"page\":-1,\"flag\":2,\"i\":5,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":5,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":6,\"j\":0},{\"page\":1,\"flag\":1,\"i\":6,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":6,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":6,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":7,\"j\":0},{\"page\":3,\"flag\":1,\"i\":7,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":7,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":7,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":8,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":8,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":8,\"j\":2},{\"page\":-1,\"flag\":2,\"i\":8,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":9,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":9,\"j\":1},{\"page\":-1,\"flag\":3,\"i\":9,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":9,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":10,\"j\":0},{\"page\":-1,\"flag\":-1,\"i\":10,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":10,\"j\":2},{\"page\":-1,\"flag\":3,\"i\":10,\"j\":3}],[{\"page\":-1,\"flag\":-1,\"i\":11,\"j\":0},{\"page\":1,\"flag\":1,\"i\":11,\"j\":1},{\"page\":-1,\"flag\":-1,\"i\":11,\"j\":2},{\"page\":-1,\"flag\":-1,\"i\":11,\"j\":3}]],\"callList\":[5,3,5,2,6,2,1,3,6,2,6,1],\"rwList\":[true,true,true,true,true,true,true,true,true,true,true,true],\"pageFaults\":[0,1,3,4,6,7,11],\"writeBacks\":[],\"strategy\":\"nfu\",\"frameCount\":4}";

    evaluateDiagram(fifoDiagram);
    log.info("Finished Fifo");
    evaluateDiagram(clockDiagram);
    log.info("Finished Clock");
    evaluateDiagram(lRUDiagram);
    log.info("Finished LRU");
    evaluateDiagram(nFUDiagram);
    log.info("Finished NFU");
  }

  private void evaluateDiagram(String diagram) throws JsonProcessingException {
    PagingDiagram pagingDiagram = new ObjectMapper().readValue(diagram, PagingDiagram.class);
    Set<Integer> wrongPageFaults = new HashSet<>();
    Set<Integer> wrongWriteBacks = new HashSet<>();
    List<TableCell> mistakesList =
        PagingService.evaluate(pagingDiagram, wrongPageFaults, wrongWriteBacks);
    assert (wrongPageFaults.isEmpty());
    assert (wrongWriteBacks.isEmpty());
    assert (mistakesList != null && mistakesList.isEmpty());
  }
}
